#if !defined(__CHECKS_H__)
#define __CHECKS_H__

void preconditionFailed(const char *p, const char *file, int line);

#ifdef _NDEBUG
#define PRECONDITION(p) ((void)0)
#else
#define PRECONDITION(p)   ((p) ? (void)0 : (void) preconditionFailed(#p,__FILE__,__LINE__) )
#endif

#endif //__CHECKS_H__
