#if !defined __IOSTRING_H__
#define __IOSTRING_H__

using namespace std;

#include <string>
#include <sstream>

template<class T>
inline std::string operator<<(std::string &str,const T &t) {
  char b[32768];
  std::ostringstream os;
  os<<t;
  return str.append(os.str());
}


template<class T>
inline void stringScan(const std::string &s, T &t) {
  std::stringstream is(s);
  is>>t;
}

template<class T>
inline void operator>>(std::string &s, T &t) {
  std::istringstream is(s);
  is>>t;
}

#endif // __IOSTRING_H__
