#include "printSequence.h"
#include "setofterms.h"

using namespace std;

bool SetOfTerms::isZeroDim() const {
	return ::isZeroDim(*this,__gnu_cxx::identity<Term>());
}

SetOfTerms SetOfTerms::nset() const {
	return ::nset(*this,__gnu_cxx::identity<Term>());
}

SetOfTerms SetOfTerms::bset() const {
	SetOfTerms bs;
	if (empty()) return bs;
	size_t n=begin()->context().abc().size();
	for (SetOfTerms::const_iterator t=begin();t!=end();++t) {
		for (size_t i=0;i<n;++i) {
			Term s=*t*t->var(i);
			if (!contains(s)) bs.insert(s);
		}
	}
	return bs;
}

void SetOfTerms::print(ostream &os) const {
	PrintSequence<const_iterator> ps(",","[","]");
	ps(os,begin(),end());
}
