#include <algorithm>
#include "printSequence.h"
#include "setofeterms.h"

using namespace std;

bool SetOfEterms::subset(const SetOfEterms &st) const {
	for (const_iterator i=begin();i!=end();++i)
		if (st.find(*i)==st.end()) return false;
	return true;
}

SetOfEterms &SetOfEterms::unite(const SetOfEterms &st) {
	for(const_iterator i=st.begin();i!=st.end();++i) insert(*i);
	return *this;
}

void SetOfEterms::print(ostream &os) const {
	PrintSequence<const_iterator> ps(",","[","]");
	ps(os,begin(),end());
}
